/*
   prototypes for energy_par.c
*/

#ifndef __VIENNA_RNA_PACKAGE_ENERGY_PAR_D_H__
#define __VIENNA_RNA_PACKAGE_ENERGY_PAR_D_H__

#include "energy_const.h"

#define PUBLIC


extern double lxc37_D;   /* parameter for logarithmic loop
			  energy extrapolation            */

extern int stack37_D[NBPAIRS+1][NBPAIRS+1];
extern int stackdH_D[NBPAIRS+1][NBPAIRS+1]; /* stack enthalpies */
extern int entropies_D[NBPAIRS+1][NBPAIRS+1];  /* not used anymore */

extern int hairpin37_D[31];
extern int hairpindH_D[31];
extern int bulge37_D[31];
extern int bulgedH_D[31];
extern int internal_loop37_D[31];
extern int internal_loopdH_D[31];
extern int internal2_energy_D;
extern int old_mismatch_37_D[NBPAIRS+1][5][5];
extern int mismatchI37_D[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatchIdH_D[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch1nI37_D[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch23I37_D[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch1nIdH_D[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatch23IdH_D[NBPAIRS+1][5][5];  /* interior loop mismatches */
extern int mismatchH37_D[NBPAIRS+1][5][5];  /* same for hairpins */
extern int mismatchM37_D[NBPAIRS+1][5][5];  /* same for multiloops */
extern int mismatchHdH_D[NBPAIRS+1][5][5];  /* same for hairpins */
extern int mismatchMdH_D[NBPAIRS+1][5][5];  /* same for multiloops */
extern int mismatchExt37_D[NBPAIRS+1][5][5];
extern int mismatchExtdH_D[NBPAIRS+1][5][5];

extern int dangle5_37_D[NBPAIRS+1][5];      /* 5' dangle exterior of pair */
extern int dangle3_37_D[NBPAIRS+1][5];      /* 3' dangle */
extern int dangle3_dH_D[NBPAIRS+1][5];       /* corresponding enthalpies */
extern int dangle5_dH_D[NBPAIRS+1][5];

extern int int11_37_D[NBPAIRS+1][NBPAIRS+1][5][5]; /* 1x1 interior loops */
extern int int11_dH_D[NBPAIRS+1][NBPAIRS+1][5][5];

extern int int21_37_D[NBPAIRS+1][NBPAIRS+1][5][5][5]; /* 2x1 interior loops */
extern int int21_dH_D[NBPAIRS+1][NBPAIRS+1][5][5][5];

extern int int22_37_D[NBPAIRS+1][NBPAIRS+1][5][5][5][5]; /* 2x2 interior loops */
extern int int22_dH_D[NBPAIRS+1][NBPAIRS+1][5][5][5][5];

/* constants for linearly destabilizing contributions for multi-loops
   F = ML_closing + ML_intern*(k-1) + ML_BASE*u  */
extern int ML_BASE37_D;
extern int ML_BASEdH_D;
extern int ML_closing37_D;
extern int ML_closingdH_D;
extern int ML_intern37_D;
extern int ML_interndH_D;

extern int DuplexInit37_D;
extern int DuplexInitdH_D;

extern int TripleC37_D;
extern int TripleCdH_D;
extern int MultipleCA37_D;
extern int MultipleCAdH_D;
extern int MultipleCB37_D;
extern int MultipleCBdH_D;

/* Ninio-correction for asymmetric internal loops with branches n1 and n2 */
/*    ninio_energy = min{max_ninio, |n1-n2|*F_ninio[min{4.0, n1, n2}] } */
extern int  MAX_NINIO_D;                   /* maximum correction */
extern int ninio37_D;
extern int niniodH_D;
/* penalty for helices terminated by AU (actually not GC) */
extern int TerminalAU37_D;
extern int TerminalAUdH_D;
/* penalty for forming bi-molecular duplex */
extern int DuplexInit37_D;
extern int DuplexInitdH_D;
/* stabilizing contribution due to special hairpins of size 4 (tetraloops) */
extern char Tetraloops_D[];  /* string containing the special tetraloops */
extern int  Tetraloop37_D[];  /* Bonus energy for special tetraloops */
extern int  TetraloopdH_D[];
extern char Triloops_D[];    /* string containing the special triloops */
extern int  Triloop37_D[]; /* Bonus energy for special Triloops */
extern int  TriloopdH_D[]; /* Bonus energy for special Triloops */
extern char Hexaloops_D[];    /* string containing the special triloops */
extern int  Hexaloop37_D[]; /* Bonus energy for special Triloops */
extern int  HexaloopdH_D[]; /* Bonus energy for special Triloops */

#endif
