/*
    Automatically generated from parameter files shipped with
    the RNAstructure program package.

    See also http://rna.urmc.rochester.edu/NNDB/index.html for
    a detailed description of the parameters we use here.

    (c) Ronny Lorenz 2016
*/

/*
     Current free energy parameters are summarized in:

     D.H. Turner and D.H Mathews
     "NNDB: the nearest neighbor parameter database for predicting stability of
      nucleic acid secondary structure"
     Nucleic Acids Res. 2010 Jan; 38(Database issue): D280-D282.

     D.H. Mathews, M.D. Disney, J.L. Childs, S.J. Schroeder, M. Zuker, D.H. Turner
     "Incorporating chemical modification constraints into a dynamic programming
      algorithm for prediction of RNA secondary structure"
     Proc. Natl Acad. Sci. USA. 2004; 101:7287-7292

     D.H. Mathews, J. Sabina, M. Zuker, D.H. Turner
     "Expanded sequence dependence of thermodynamic parameters improves
     prediction of RNA secondary structure"
     JMB, 288, pp 911-940, 1999

     Enthalpies taken from:

     A. Walter, D Turner, J Kim, M Lyttle, P M"uller, D Mathews, M Zuker
     "Coaxial stacking of helices enhances binding of oligoribonucleotides.."
     PNAS, 91, pp 9218-9222, 1994

     D.H. Turner, N. Sugimoto, and S.M. Freier.
     "RNA Structure Prediction",
     Ann. Rev. Biophys. Biophys. Chem. 17, 167-192, 1988.

     John A.Jaeger, Douglas H.Turner, and Michael Zuker.
     "Improved predictions of secondary structures for RNA",
     PNAS, 86, 7706-7710, October 1989.

     L. He, R. Kierzek, J. SantaLucia, A.E. Walter, D.H. Turner
     "Nearest-Neighbor Parameters for GU Mismatches...."
     Biochemistry 1991, 30 11124-11132

     A.E. Peritz, R. Kierzek, N, Sugimoto, D.H. Turner
     "Thermodynamic Study of Internal Loops in Oligoribonucleotides..."
     Biochemistry 1991, 30, 6428--6435
*/

/* RNAfold parameters v2.x */
/* RNA parameters */


#include "ViennaRNA/energy_const.h"

#define NST 0     /* Energy for nonstandard stacked pairs */
#define DEF -50   /* Default terminal mismatch, used for I */
                  /* and any non_pairing bases */
#define NSM 0     /* terminal mismatch for non standard pairs */

#define PUBLIC

PUBLIC double Tmeasure = 37+K0;  /* temperature of param measurements */


PUBLIC double lxc37     = 107.90;
PUBLIC double lxcdH     =   0.00;
PUBLIC int ML_intern37  =    -60;
PUBLIC int ML_interndH  =   -220;
PUBLIC int ML_closing37 =    930;
PUBLIC int ML_closingdH =   3000;
PUBLIC int ML_BASE37    =     -0;
PUBLIC int ML_BASEdH    =      0;
PUBLIC int MAX_NINIO    =    300;
PUBLIC int ninio37      =     60;
PUBLIC int niniodH      =    320;
PUBLIC int TerminalAU37 =     50;
PUBLIC int TerminalAUdH =    370;
PUBLIC int DuplexInit37 =    410;
PUBLIC int DuplexInitdH =    360;

PUBLIC int TripleC37    =    150;
PUBLIC int TripleCdH    =   1860;
PUBLIC int MultipleCA37 =     30;
PUBLIC int MultipleCAdH =    340;
PUBLIC int MultipleCB37 =    160;
PUBLIC int MultipleCBdH =    760;

PUBLIC int GQuadAlpha37 = -1800;
PUBLIC int GQuadAlphadH = -11934;
PUBLIC int GQuadBeta37  = 1200;
PUBLIC int GQuadBetadH  = 0;
PUBLIC int stack37[NBPAIRS+1][NBPAIRS+1] = 
/*     NP      CG      GC      GU      UG      AU      UA      NN        */
{{    INF,    INF,    INF,    INF,    INF,    INF,    INF,    INF} /* NP */
,{    INF,   -240,   -330,   -210,   -140,   -210,   -210,   -140} /* CG */
,{    INF,   -330,   -340,   -250,   -150,   -220,   -240,   -150} /* GC */
,{    INF,   -210,   -250,    130,    -50,   -140,   -130,    130} /* GU */
,{    INF,   -140,   -150,    -50,     30,    -60,   -100,     30} /* UG */
,{    INF,   -210,   -220,   -140,    -60,   -110,    -90,    -60} /* AU */
,{    INF,   -210,   -240,   -130,   -100,    -90,   -130,    -90} /* UA */
,{    INF,   -140,   -150,    130,     30,    -60,    -90,    130} /* NN */
};
PUBLIC int stackdH[NBPAIRS+1][NBPAIRS+1] = 
/*     NP      CG      GC      GU      UG      AU      UA      NN        */
{{    INF,    INF,    INF,    INF,    INF,    INF,    INF,    INF} /* NP */
,{    INF,  -1060,  -1340,  -1210,   -560,  -1050,  -1040,   -560} /* CG */
,{    INF,  -1340,  -1490,  -1260,   -830,  -1140,  -1240,   -830} /* GC */
,{    INF,  -1210,  -1260,  -1460,  -1350,   -880,  -1280,   -880} /* GU */
,{    INF,   -560,   -830,  -1350,   -930,   -320,   -700,   -320} /* UG */
,{    INF,  -1050,  -1140,   -880,   -320,   -940,   -680,   -320} /* AU */
,{    INF,  -1040,  -1240,  -1280,   -700,   -680,   -770,   -680} /* UA */
,{    INF,   -560,   -830,   -880,   -320,   -320,   -680,   -320} /* NN */
};
PUBLIC int hairpin37[31] = {   INF,   INF,   INF,    540,    560,    570,    540,    600,    550,    640,    650,    660,    670,    680,    690,    690,    700,    710,    710,    720,    720,    730,    730,    740,    740,    750,    750,    750,    760,    760,    770};
PUBLIC int hairpindH[31] = {   INF,   INF,   INF,    130,    480,    360,   -290,    130,   -290,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500,    500};
PUBLIC int bulge37[31] = {   INF,    380,    280,    320,    360,    400,    440,    460,    470,    480,    490,    500,    510,    520,    530,    540,    540,    550,    550,    560,    570,    570,    580,    580,    580,    590,    590,    600,    600,    600,    610};
PUBLIC int bulgedH[31] = {   INF,   1060,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710,    710};
PUBLIC int internal_loop37[31] = {   INF,   INF,   INF,   INF,    110,    200,    200,    210,    230,    240,    250,    260,    270,    280,    290,    290,    300,    310,    310,    320,    330,    330,    340,    340,    350,    350,    350,    360,    360,    370,    370};
PUBLIC int internal_loopdH[31] = {   INF,   INF,   INF,   INF,   -720,   -680,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130,   -130};
PUBLIC int mismatchI37[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,    -80,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,   -100,      0,   -100,      0} /* G */
 ,{      0,      0,      0,      0,    -60} /* U */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,    -80,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,   -100,      0,   -100,      0} /* G */
 ,{      0,      0,      0,      0,    -60} /* U */
 }
,/* GU */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,    -10,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -30,     70,    -30,     70} /* G */
 ,{     70,     70,     70,     70,     10} /* U */
 }
,/* UG */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,    -10,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -30,     70,    -30,     70} /* G */
 ,{     70,     70,     70,     70,     10} /* U */
 }
,/* AU */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,    -10,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -30,     70,    -30,     70} /* G */
 ,{     70,     70,     70,     70,     10} /* U */
 }
,/* UA */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,    -10,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -30,     70,    -30,     70} /* G */
 ,{     70,     70,     70,     70,     10} /* U */
 }
,/* NN */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,    -10,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -30,     70,    -30,     70} /* G */
 ,{     70,     70,     70,     70,     10} /* U */
 }
};
PUBLIC int mismatchIdH[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{    280,      0,      0,    280,      0} /* E */
 ,{      0,      0,      0,   -340,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{    280,   -760,      0,    280,      0} /* G */
 ,{      0,      0,      0,      0,   -580} /* U */
 }
,/* GC */
 {{    280,      0,      0,    280,      0} /* E */
 ,{      0,      0,      0,   -340,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{    280,   -760,      0,    280,      0} /* G */
 ,{      0,      0,      0,      0,   -580} /* U */
 }
,/* GU */
 {{    790,    500,    500,    790,    500} /* E */
 ,{    500,    500,    500,    170,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    790,   -260,    500,    790,    500} /* G */
 ,{    500,    500,    500,    500,    -80} /* U */
 }
,/* UG */
 {{    790,    500,    500,    790,    500} /* E */
 ,{    500,    500,    500,    170,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    790,   -260,    500,    790,    500} /* G */
 ,{    500,    500,    500,    500,    -80} /* U */
 }
,/* AU */
 {{    790,    500,    500,    790,    500} /* E */
 ,{    500,    500,    500,    170,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    790,   -260,    500,    790,    500} /* G */
 ,{    500,    500,    500,    500,    -80} /* U */
 }
,/* UA */
 {{    790,    500,    500,    790,    500} /* E */
 ,{    500,    500,    500,    170,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    790,   -260,    500,    790,    500} /* G */
 ,{    500,    500,    500,    500,    -80} /* U */
 }
,/* NN */
 {{    790,    500,    500,    790,    500} /* E */
 ,{    500,    500,    500,    170,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    790,   -260,    500,    790,    500} /* G */
 ,{    500,    500,    500,    500,    -80} /* U */
 }
};
PUBLIC int mismatchH37[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{    -80,   -100,   -110,   -100,    -80} /* E */
 ,{   -140,   -150,   -150,   -140,   -150} /* A */
 ,{    -80,   -100,   -110,   -100,    -80} /* C */
 ,{   -150,   -230,   -150,   -240,   -150} /* G */
 ,{   -100,   -100,   -140,   -100,   -210} /* U */
 }
,/* GC */
 {{    -50,   -110,    -70,   -110,    -50} /* E */
 ,{   -110,   -110,   -150,   -130,   -150} /* A */
 ,{    -50,   -110,    -70,   -110,    -50} /* C */
 ,{   -150,   -250,   -150,   -220,   -150} /* G */
 ,{   -100,   -110,   -100,   -110,   -160} /* U */
 }
,/* GU */
 {{     20,     20,    -20,    -10,    -20} /* E */
 ,{     20,     20,    -50,    -30,    -50} /* A */
 ,{    -10,    -10,    -20,    -10,    -20} /* C */
 ,{    -50,   -100,    -50,   -110,    -50} /* G */
 ,{    -10,    -10,    -30,    -10,   -100} /* U */
 }
,/* UG */
 {{     -0,    -20,    -10,    -20,     -0} /* E */
 ,{    -30,    -50,    -30,    -60,    -30} /* A */
 ,{     -0,    -20,    -10,    -20,     -0} /* C */
 ,{    -30,    -90,    -30,   -110,    -30} /* G */
 ,{    -10,    -20,    -10,    -20,    -90} /* U */
 }
,/* AU */
 {{    -10,    -10,    -20,    -10,    -20} /* E */
 ,{    -30,    -30,    -50,    -30,    -50} /* A */
 ,{    -10,    -10,    -20,    -10,    -20} /* C */
 ,{    -50,   -120,    -50,   -110,    -50} /* G */
 ,{    -10,    -10,    -30,    -10,   -120} /* U */
 }
,/* UA */
 {{     -0,    -20,    -10,    -20,     -0} /* E */
 ,{    -30,    -50,    -30,    -50,    -30} /* A */
 ,{     -0,    -20,    -10,    -20,     -0} /* C */
 ,{    -30,   -150,    -30,   -150,    -30} /* G */
 ,{    -10,    -20,    -10,    -20,    -90} /* U */
 }
,/* NN */
 {{     20,     20,    -10,    -10,     -0} /* E */
 ,{     20,     20,    -30,    -30,    -30} /* A */
 ,{     -0,    -10,    -10,    -10,     -0} /* C */
 ,{    -30,    -90,    -30,   -110,    -30} /* G */
 ,{    -10,    -10,    -10,    -10,    -90} /* U */
 }
};
PUBLIC int mismatchHdH[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{    560,   -570,    560,   -560,   -270} /* E */
 ,{   -560,   -910,   -560,   -560,   -560} /* A */
 ,{   -270,   -570,   -340,   -570,   -270} /* C */
 ,{    560,  -1400,    560,   -920,   -560} /* G */
 ,{   -530,   -570,   -530,   -570,  -1440} /* U */
 }
,/* GC */
 {{     50,   -520,     50,   -560,   -400} /* E */
 ,{   -400,   -520,   -400,   -560,   -400} /* A */
 ,{     50,   -720,     50,   -720,   -420} /* C */
 ,{   -400,  -1290,   -400,   -620,   -400} /* G */
 ,{    -30,   -720,    -30,   -720,  -1080} /* U */
 }
,/* GU */
 {{    970,    140,    970,    140,    570} /* E */
 ,{    570,     30,    570,     20,    570} /* A */
 ,{    970,    140,    970,    140,    340} /* C */
 ,{    570,   -270,    570,     20,    570} /* G */
 ,{    830,    140,    830,    140,    -50} /* U */
 }
,/* UG */
 {{    230,    100,    230,    220,    190} /* E */
 ,{   -110,   -110,   -260,   -520,   -260} /* A */
 ,{    190,    -60,   -140,    -60,    190} /* C */
 ,{    220,    100,   -260,    220,   -260} /* G */
 ,{    230,    -60,    230,    -60,    -70} /* U */
 }
,/* AU */
 {{    970,    140,    970,    140,    570} /* E */
 ,{    570,    -20,    570,     20,    570} /* A */
 ,{    970,    140,    970,    140,    340} /* C */
 ,{    570,   -520,    570,     20,    570} /* G */
 ,{    830,    140,    830,    140,   -380} /* U */
 }
,/* UA */
 {{    230,    -30,    230,    -60,    190} /* E */
 ,{    -30,    -30,   -260,   -520,   -260} /* A */
 ,{    190,    -60,   -140,    -60,    190} /* C */
 ,{   -260,   -590,   -260,   -520,   -260} /* G */
 ,{    230,    -60,    230,    -60,    -70} /* U */
 }
,/* NN */
 {{    970,    140,    970,    220,    570} /* E */
 ,{    570,     30,    570,     20,    570} /* A */
 ,{    970,    140,    970,    140,    340} /* C */
 ,{    570,    100,    570,    220,    570} /* G */
 ,{    830,    140,    830,    140,    -50} /* U */
 }
};
PUBLIC int mismatchM37[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{    -50,   -110,    -50,   -140,    -70} /* E */
 ,{   -110,   -110,   -110,   -160,   -110} /* A */
 ,{    -70,   -150,    -70,   -150,   -100} /* C */
 ,{   -110,   -130,   -110,   -140,   -110} /* G */
 ,{    -50,   -150,    -50,   -150,    -70} /* U */
 }
,/* GC */
 {{    -80,   -140,    -80,   -140,   -100} /* E */
 ,{   -100,   -150,   -100,   -140,   -100} /* A */
 ,{   -110,   -150,   -110,   -150,   -140} /* C */
 ,{   -100,   -140,   -100,   -160,   -100} /* G */
 ,{    -80,   -150,    -80,   -150,   -120} /* U */
 }
,/* GU */
 {{    -50,    -80,    -50,    -50,    -50} /* E */
 ,{    -50,   -100,    -70,    -50,    -70} /* A */
 ,{    -60,    -80,    -60,    -80,    -60} /* C */
 ,{    -70,   -110,    -70,    -80,    -70} /* G */
 ,{    -50,    -80,    -50,    -80,    -50} /* U */
 }
,/* UG */
 {{    -30,    -30,    -60,    -60,    -60} /* E */
 ,{    -30,    -30,    -60,    -60,    -60} /* A */
 ,{    -70,   -100,    -70,   -100,    -80} /* C */
 ,{    -60,    -80,    -60,    -80,    -60} /* G */
 ,{    -60,   -100,    -70,   -100,    -60} /* U */
 }
,/* AU */
 {{    -50,    -80,    -50,    -80,    -50} /* E */
 ,{    -70,   -100,    -70,   -110,    -70} /* A */
 ,{    -60,    -80,    -60,    -80,    -60} /* C */
 ,{    -70,   -110,    -70,   -120,    -70} /* G */
 ,{    -50,    -80,    -50,    -80,    -50} /* U */
 }
,/* UA */
 {{    -60,    -80,    -60,    -80,    -60} /* E */
 ,{    -60,    -80,    -60,    -80,    -60} /* A */
 ,{    -70,   -100,    -70,   -100,    -80} /* C */
 ,{    -60,    -80,    -60,    -80,    -60} /* G */
 ,{    -70,   -100,    -70,   -100,    -80} /* U */
 }
,/* NN */
 {{    -30,    -30,    -50,    -50,    -50} /* E */
 ,{    -30,    -30,    -60,    -50,    -60} /* A */
 ,{    -60,    -80,    -60,    -80,    -60} /* C */
 ,{    -60,    -80,    -60,    -80,    -60} /* G */
 ,{    -50,    -80,    -50,    -80,    -50} /* U */
 }
};
PUBLIC int mismatchMdH[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{     50,   -400,     50,   -400,    -30} /* E */
 ,{   -520,   -520,   -720,   -710,   -720} /* A */
 ,{     50,   -400,     50,   -400,    -30} /* C */
 ,{   -560,   -560,   -720,   -620,   -720} /* G */
 ,{   -400,   -400,   -420,   -400,   -500} /* U */
 }
,/* GC */
 {{   -270,   -560,   -270,   -560,   -530} /* E */
 ,{   -570,   -910,   -570,   -820,   -570} /* A */
 ,{   -340,   -560,   -340,   -560,   -530} /* C */
 ,{   -560,   -560,   -570,   -920,   -570} /* G */
 ,{   -270,   -560,   -270,   -560,   -860} /* U */
 }
,/* GU */
 {{    310,   -480,   -180,    310,    140} /* E */
 ,{    310,   -480,   -430,    310,   -430} /* A */
 ,{   -140,   -630,   -510,   -630,   -140} /* C */
 ,{   -150,   -890,   -430,   -150,   -430} /* G */
 ,{    140,   -630,   -180,   -630,    140} /* U */
 }
,/* UG */
 {{    600,    200,    600,    200,    460} /* E */
 ,{    -60,   -340,   -230,    -60,   -230} /* A */
 ,{    600,    200,    600,    200,    460} /* C */
 ,{   -230,   -350,   -230,   -350,   -230} /* G */
 ,{    200,    200,    -30,    200,    160} /* U */
 }
,/* AU */
 {{    140,   -400,   -180,   -380,    140} /* E */
 ,{   -380,   -400,   -430,   -380,   -430} /* A */
 ,{   -140,   -630,   -510,   -630,   -140} /* C */
 ,{   -430,   -890,   -430,   -890,   -430} /* G */
 ,{    140,   -630,   -180,   -630,    140} /* U */
 }
,/* UA */
 {{    600,    200,    600,    200,    460} /* E */
 ,{   -230,   -390,   -230,   -310,   -230} /* A */
 ,{    600,    200,    600,    200,    460} /* C */
 ,{   -230,   -350,   -230,   -350,   -230} /* G */
 ,{    200,    200,    -30,    200,   -170} /* U */
 }
,/* NN */
 {{    600,    200,    600,    310,    460} /* E */
 ,{    310,   -340,   -230,    310,   -230} /* A */
 ,{    600,    200,    600,    200,    460} /* C */
 ,{   -150,   -350,   -230,   -150,   -230} /* G */
 ,{    200,    200,    -30,    200,    160} /* U */
 }
};
PUBLIC int mismatch1nI37[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U */
 }
,/* GU */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,     70,     70,     70,     70} /* G */
 ,{     70,     70,     70,     70,     70} /* U */
 }
,/* UG */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,     70,     70,     70,     70} /* G */
 ,{     70,     70,     70,     70,     70} /* U */
 }
,/* AU */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,     70,     70,     70,     70} /* G */
 ,{     70,     70,     70,     70,     70} /* U */
 }
,/* UA */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,     70,     70,     70,     70} /* G */
 ,{     70,     70,     70,     70,     70} /* U */
 }
,/* NN */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,     70,     70,     70,     70} /* G */
 ,{     70,     70,     70,     70,     70} /* U */
 }
};
PUBLIC int mismatch1nIdH[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,      0,      0,      0,      0} /* G */
 ,{      0,      0,      0,      0,      0} /* U */
 }
,/* GU */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,    500,    500,    500,    500} /* G */
 ,{    500,    500,    500,    500,    500} /* U */
 }
,/* UG */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,    500,    500,    500,    500} /* G */
 ,{    500,    500,    500,    500,    500} /* U */
 }
,/* AU */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,    500,    500,    500,    500} /* G */
 ,{    500,    500,    500,    500,    500} /* U */
 }
,/* UA */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,    500,    500,    500,    500} /* G */
 ,{    500,    500,    500,    500,    500} /* U */
 }
,/* NN */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,    500,    500,    500,    500} /* G */
 ,{    500,    500,    500,    500,    500} /* U */
 }
};
PUBLIC int mismatch23I37[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,    -50,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,   -110,      0,    -70,      0} /* G */
 ,{      0,      0,      0,      0,    -30} /* U */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,   -120,      0,    -70,      0} /* G */
 ,{      0,      0,      0,      0,    -30} /* U */
 }
,/* GU */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -40,     70,      0,     70} /* G */
 ,{     70,     70,     70,     70,     40} /* U */
 }
,/* UG */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     20,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -40,     70,      0,     70} /* G */
 ,{     70,     70,     70,     70,     40} /* U */
 }
,/* AU */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -40,     70,      0,     70} /* G */
 ,{     70,     70,     70,     70,     40} /* U */
 }
,/* UA */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     20,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -40,     70,      0,     70} /* G */
 ,{     70,     70,     70,     70,     40} /* U */
 }
,/* NN */
 {{     70,     70,     70,     70,     70} /* E */
 ,{     70,     70,     70,     70,     70} /* A */
 ,{     70,     70,     70,     70,     70} /* C */
 ,{     70,    -40,     70,      0,     70} /* G */
 ,{     70,     70,     70,     70,     40} /* U */
 }
};
PUBLIC int mismatch23IdH[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,   -570,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,   -860,      0,   -900,      0} /* G */
 ,{      0,      0,      0,      0,   -640} /* U */
 }
,/* GC */
 {{      0,      0,      0,      0,      0} /* E */
 ,{      0,      0,      0,      0,      0} /* A */
 ,{      0,      0,      0,      0,      0} /* C */
 ,{      0,  -1090,      0,   -900,      0} /* G */
 ,{      0,      0,      0,      0,   -640} /* U */
 }
,/* GU */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,   -580,    500,   -400,    500} /* G */
 ,{    500,    500,    500,    500,   -140} /* U */
 }
,/* UG */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    -60,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,   -360,    500,   -400,    500} /* G */
 ,{    500,    500,    500,    500,   -140} /* U */
 }
,/* AU */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,   -580,    500,   -400,    500} /* G */
 ,{    500,    500,    500,    500,   -140} /* U */
 }
,/* UA */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    -60,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,   -360,    500,   -400,    500} /* G */
 ,{    500,    500,    500,    500,   -140} /* U */
 }
,/* NN */
 {{    500,    500,    500,    500,    500} /* E */
 ,{    500,    500,    500,    500,    500} /* A */
 ,{    500,    500,    500,    500,    500} /* C */
 ,{    500,   -360,    500,   -400,    500} /* G */
 ,{    500,    500,    500,    500,   -140} /* U */
 }
};
PUBLIC int mismatchExt37[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{    -50,   -110,    -50,   -140,    -70} /* E */
 ,{   -110,   -110,   -110,   -160,   -110} /* A */
 ,{    -70,   -150,    -70,   -150,   -100} /* C */
 ,{   -110,   -130,   -110,   -140,   -110} /* G */
 ,{    -50,   -150,    -50,   -150,    -70} /* U */
 }
,/* GC */
 {{    -80,   -140,    -80,   -140,   -100} /* E */
 ,{   -100,   -150,   -100,   -140,   -100} /* A */
 ,{   -110,   -150,   -110,   -150,   -140} /* C */
 ,{   -100,   -140,   -100,   -160,   -100} /* G */
 ,{    -80,   -150,    -80,   -150,   -120} /* U */
 }
,/* GU */
 {{    -50,    -80,    -50,    -50,    -50} /* E */
 ,{    -50,   -100,    -70,    -50,    -70} /* A */
 ,{    -60,    -80,    -60,    -80,    -60} /* C */
 ,{    -70,   -110,    -70,    -80,    -70} /* G */
 ,{    -50,    -80,    -50,    -80,    -50} /* U */
 }
,/* UG */
 {{    -30,    -30,    -60,    -60,    -60} /* E */
 ,{    -30,    -30,    -60,    -60,    -60} /* A */
 ,{    -70,   -100,    -70,   -100,    -80} /* C */
 ,{    -60,    -80,    -60,    -80,    -60} /* G */
 ,{    -60,   -100,    -70,   -100,    -60} /* U */
 }
,/* AU */
 {{    -50,    -80,    -50,    -80,    -50} /* E */
 ,{    -70,   -100,    -70,   -110,    -70} /* A */
 ,{    -60,    -80,    -60,    -80,    -60} /* C */
 ,{    -70,   -110,    -70,   -120,    -70} /* G */
 ,{    -50,    -80,    -50,    -80,    -50} /* U */
 }
,/* UA */
 {{    -60,    -80,    -60,    -80,    -60} /* E */
 ,{    -60,    -80,    -60,    -80,    -60} /* A */
 ,{    -70,   -100,    -70,   -100,    -80} /* C */
 ,{    -60,    -80,    -60,    -80,    -60} /* G */
 ,{    -70,   -100,    -70,   -100,    -80} /* U */
 }
,/* NN */
 {{    -30,    -30,    -50,    -50,    -50} /* E */
 ,{    -30,    -30,    -60,    -50,    -60} /* A */
 ,{    -60,    -80,    -60,    -80,    -60} /* C */
 ,{    -60,    -80,    -60,    -80,    -60} /* G */
 ,{    -50,    -80,    -50,    -80,    -50} /* U */
 }
};
PUBLIC int mismatchExtdH[NBPAIRS+1][5][5] = 
{/* NP */
 {{    INF,    INF,    INF,    INF,    INF} /* E */
 ,{    INF,    INF,    INF,    INF,    INF} /* A */
 ,{    INF,    INF,    INF,    INF,    INF} /* C */
 ,{    INF,    INF,    INF,    INF,    INF} /* G */
 ,{    INF,    INF,    INF,    INF,    INF} /* U */
 }
,/* CG */
 {{     50,   -400,     50,   -400,    -30} /* E */
 ,{   -520,   -520,   -720,   -710,   -720} /* A */
 ,{     50,   -400,     50,   -400,    -30} /* C */
 ,{   -560,   -560,   -720,   -620,   -720} /* G */
 ,{   -400,   -400,   -420,   -400,   -500} /* U */
 }
,/* GC */
 {{   -270,   -560,   -270,   -560,   -530} /* E */
 ,{   -570,   -910,   -570,   -820,   -570} /* A */
 ,{   -340,   -560,   -340,   -560,   -530} /* C */
 ,{   -560,   -560,   -570,   -920,   -570} /* G */
 ,{   -270,   -560,   -270,   -560,   -860} /* U */
 }
,/* GU */
 {{    310,   -480,   -180,    310,    140} /* E */
 ,{    310,   -480,   -430,    310,   -430} /* A */
 ,{   -140,   -630,   -510,   -630,   -140} /* C */
 ,{   -150,   -890,   -430,   -150,   -430} /* G */
 ,{    140,   -630,   -180,   -630,    140} /* U */
 }
,/* UG */
 {{    600,    200,    600,    200,    460} /* E */
 ,{    -60,   -340,   -230,    -60,   -230} /* A */
 ,{    600,    200,    600,    200,    460} /* C */
 ,{   -230,   -350,   -230,   -350,   -230} /* G */
 ,{    200,    200,    -30,    200,    160} /* U */
 }
,/* AU */
 {{    140,   -400,   -180,   -380,    140} /* E */
 ,{   -380,   -400,   -430,   -380,   -430} /* A */
 ,{   -140,   -630,   -510,   -630,   -140} /* C */
 ,{   -430,   -890,   -430,   -890,   -430} /* G */
 ,{    140,   -630,   -180,   -630,    140} /* U */
 }
,/* UA */
 {{    600,    200,    600,    200,    460} /* E */
 ,{   -230,   -390,   -230,   -310,   -230} /* A */
 ,{    600,    200,    600,    200,    460} /* C */
 ,{   -230,   -350,   -230,   -350,   -230} /* G */
 ,{    200,    200,    -30,    200,   -170} /* U */
 }
,/* NN */
 {{    600,    200,    600,    310,    460} /* E */
 ,{    310,   -340,   -230,    310,   -230} /* A */
 ,{    600,    200,    600,    200,    460} /* C */
 ,{   -150,   -350,   -230,   -150,   -230} /* G */
 ,{    200,    200,    -30,    200,    160} /* U */
 }
};
PUBLIC int dangle5_37[NBPAIRS+1][5] = 
/*      E       A       C       G       U        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -10,    -50,    -30,    -20,    -10} /* CG */
,{     -0,    -20,    -30,     -0,     -0} /* GC */
,{    -20,    -30,    -30,    -40,    -20} /* GU */
,{    -10,    -30,    -10,    -20,    -20} /* UG */
,{    -20,    -30,    -30,    -40,    -20} /* AU */
,{    -10,    -30,    -10,    -20,    -20} /* UA */
,{     -0,    -20,    -10,     -0,     -0} /* NN */
};
PUBLIC int dangle5_dH[NBPAIRS+1][5] = 
/*      E       A       C       G       U        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    330,   -240,    330,     80,   -140} /* CG */
,{     70,   -160,     70,   -460,    -40} /* GC */
,{    310,    160,    220,     70,    310} /* GU */
,{    690,    -50,    690,     60,     60} /* UG */
,{    310,    160,    220,     70,    310} /* AU */
,{    690,    -50,    690,     60,     60} /* UA */
,{    690,    160,    690,     80,    310} /* NN */
};
PUBLIC int dangle3_37[NBPAIRS+1][5] = 
/*      E       A       C       G       U        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{    -40,   -110,    -40,   -130,    -60} /* CG */
,{    -80,   -170,    -80,   -170,   -120} /* GC */
,{    -10,    -70,    -10,    -70,    -10} /* GU */
,{    -50,    -80,    -50,    -80,    -60} /* UG */
,{    -10,    -70,    -10,    -70,    -10} /* AU */
,{    -50,    -80,    -50,    -80,    -60} /* UA */
,{    -10,    -70,    -10,    -70,    -10} /* NN */
};
PUBLIC int dangle3_dH[NBPAIRS+1][5] = 
/*      E       A       C       G       U        */
{{    INF,    INF,    INF,    INF,    INF} /* NP */
,{   -280,   -740,   -280,   -640,   -360} /* CG */
,{   -410,   -900,   -410,   -860,   -750} /* GC */
,{    -70,   -570,    -70,   -580,   -220} /* GU */
,{    -90,   -490,    -90,   -550,   -230} /* UG */
,{    -70,   -570,    -70,   -580,   -220} /* AU */
,{    -90,   -490,    -90,   -550,   -230} /* UA */
,{    -70,   -490,    -70,   -550,   -220} /* NN */
};
PUBLIC int Hexaloop37[40] = {    280,    360,    290,    180};
PUBLIC int HexaloopdH[40] = {  -1680,  -1140,  -1280,  -1540};

PUBLIC char Hexaloops[361] = 
  "ACAGUACU "
  "ACAGUGAU "
  "ACAGUGCU "
  "ACAGUGUU "
  "";
PUBLIC int Tetraloop37[40] = {    550,    330,    370,    340,    350,    360,    370,    250,    360,    280,    370,    270,    280,    350,    370,    370};
PUBLIC int TetraloopdH[40] = {    690,  -1030,   -330,   -890,   -660,   -750,   -350,  -1390,   -760,  -1070,   -660,  -1290,  -1070,   -620,  -1530,   -680};

PUBLIC char Tetraloops[281] = 
  "CAACGG "
  "CCAAGG "
  "CCACGG "
  "CCCAGG "
  "CCGAGG "
  "CCGCGG "
  "CCUAGG "
  "CCUCGG "
  "CUAAGG "
  "CUACGG "
  "CUCAGG "
  "CUCCGG "
  "CUGCGG "
  "CUUAGG "
  "CUUCGG "
  "CUUUGG "
  "";
PUBLIC int Triloop37[40] = {    680,    690};
PUBLIC int TriloopdH[40] = {   2370,   1080};

PUBLIC char Triloops[241] = 
  "CAACG "
  "GUUAC "
  "";
#include "intl11.h"
#include "intl11dH.h"
#include "intl21.h"
#include "intl21dH.h"
#include "intl22.h"
#include "intl22dH.h"


